searchNodes=[{"ref":"AuthToken.html","title":"AuthToken","type":"module","doc":"Simplified encrypted authentication tokens using JWE. Configuration needed: config :authtoken, token_key: PUT_KEY_HERE Generate a token for your user after successful authentication like this: Examples token_content = %{userid: user.id} token = AuthToken.generate_token(token_content)"},{"ref":"AuthToken.html#decrypt_token/1","title":"AuthToken.decrypt_token/1","type":"function","doc":"Decrypt an authentication token Format &quot;bearer: tokengoeshere&quot; and &quot;bearer tokengoeshere&quot; will be accepted and parsed out."},{"ref":"AuthToken.html#generate_key/0","title":"AuthToken.generate_key/0","type":"function","doc":"Generate a random key for AES128 Examples iex&gt; AuthToken.generate_key() {:ok, &lt;&lt;153, 67, 252, 211, 199, 186, 212, 114, 109, 99, 222, 205, 31, 26, 100, 253&gt;&gt;}"},{"ref":"AuthToken.html#generate_token/1","title":"AuthToken.generate_token/1","type":"function","doc":"Generates an encrypted auth token. Contains an encoded version of the provided map, plus a timestamp for timeout and refresh."},{"ref":"AuthToken.html#get_config/1","title":"AuthToken.get_config/1","type":"function","doc":""},{"ref":"AuthToken.html#is_timedout?/1","title":"AuthToken.is_timedout?/1","type":"function","doc":"Check if token is timedout and not valid anymore"},{"ref":"AuthToken.html#needs_refresh?/1","title":"AuthToken.needs_refresh?/1","type":"function","doc":"Check if token is stale and needs to be refreshed"},{"ref":"AuthToken.html#refresh_token/1","title":"AuthToken.refresh_token/1","type":"function","doc":"Checks a token and refreshes if necessary. Examples case AuthToken.refresh_token(token) do {:error, :timedout} -&gt; # Redirect to login {:error, :stillfresh} -&gt; # Do nothing {:ok, token} -&gt; # Check credentials and send back new token end"},{"ref":"AuthToken.Plug.html","title":"AuthToken.Plug","type":"module","doc":"Plugs for AuthToken Examples import AuthToken.Plug pipeline :auth do plug :verify_token end scope &quot;/protected/route&quot;, MyApp do pipe_through :auth resources &quot;/&quot;, DoNastyStuffController end"},{"ref":"AuthToken.Plug.html#verify_token/2","title":"AuthToken.Plug.verify_token/2","type":"function","doc":"Checks authentication token from authorization header. If this fails, send 401 with message &quot;error&quot;: &quot;auth_fail&quot; or &quot;error&quot;: &quot;timeout&quot; as JSON"},{"ref":"readme.html","title":"Authtoken","type":"extras","doc":"Authtoken Simplified encrypted authentication tokens using JWE. This package provides you with a simplified headerless and encrypted JWT. It provides you with sane defaults (AES128) and almost no configuration to counteract JWTs overblown standard. See this blog post for more information. Example integration here in Sealas"},{"ref":"readme.html#installation","title":"Authtoken - Installation","type":"extras","doc":"Add authtoken to your list of dependencies in mix.exs: def deps do [ {:authtoken, &quot;~&gt; 0.3&quot;} ] end Configure authtoken. The minimum amount of configuration needed is a key for encryption. config :authtoken, token_key: &lt;&lt;1, 2, 3, 230, 103, 242, 149, 254, 4, 33, 137, 240, 23, 90, 99, 250&gt;&gt; You can generate this with iex&gt; AuthToken.generate_key() {:ok, &lt;&lt;1, 2, 3, 230, 103, 242, 149, 254, 4, 33, 137, 240, 23, 90, 99, 250&gt;&gt;}"},{"ref":"readme.html#usage","title":"Authtoken - Usage","type":"extras","doc":"Generate a token for your user after successful authentication like this: token_content = %{userid: user.id} {:ok, token} = AuthToken.generate_token(token_content) then pass it on to your view. Get the content / Decrypting The most likely use-case is going to be you wanting to decrypt a token you have received in the request headers. {:ok, token} = AuthToken.decrypt_token(conn) user_id = token.userid Refreshing By default a token should be refreshed every 30 minutes, using AuthToken.refresh_token/1. You can pass either a decrypted token, or simply the token you get from the client directly. This will extend the lifetime of the token for another 30 minutes until it expires completely. You can use this opportunity to check if the user&#39;s credentials haven&#39;t been revoked in the meantime. case AuthToken.refresh_token(token) do {:error, :timedout} -&gt; # Redirect to login {:error, :stillfresh} -&gt; # Do nothing {:ok, token} -&gt; # Check credentials and send back new token end Plug For verification you can use the plug AuthToken.Plug.verify_token. import AuthToken.Plug pipeline :auth do plug :verify_token end scope &quot;/protected/route&quot;, MyApp do pipe_through :auth resources &quot;/&quot;, DoNastyStuffController end More detailed documentation can be found here: https://hexdocs.pm/authtoken."},{"ref":"readme.html#configuration","title":"Authtoken - Configuration","type":"extras","doc":"More optional configuration options timeout (default: 86400) Denotes the lifetime of a token in seconds. After it expires you need to generate a new one. refresh (default: 1800) The total duration after which the token needs to be refreshd"}]